import os

def B2KMG(B):
    if B>=1024**3:
        return str(round(B/1024**3,1))+' GB'
    elif B>=1024**2:
        return str(round(B/1024**2,1))+' MB'
    elif B>=1024:
        return str(round(B/1024,1))+' KB'
    else:
        return str(B)+' B'

def showFiles(path,deep=False):
    try:
        files=os.listdir(path)
    except:
        print(path,'不是一个目录！')
        return
    print(path) #显示全目录名
    onlyFiles=[]  #放置非目录的文件
    i=0
    while i!=len(files):   #显示一层目录中的纯目录
        fullFileName=os.path.join(path,files[i])
        if os.path.isdir(fullFileName): #目录
            print('\t%6s  %s'%('<目录>',files[i]))
            i+=1
        else: #文件
            onlyFiles.append(files[i])
            del files[i]     #删除列表中的文件项
    for file in onlyFiles:  #显示一层目录中的纯文件
        print("\t%8s  %s"%(
B2KMG(os.path.getsize(os.path.join(path,file))),file))
    del onlyFiles  #删除文件项以节约存储空间
    if deep:  #显示所有子目录中的文件和子目录，递归
        while len(files)!=0:
            showFiles(os.path.join(path,files[0]),True)
            del files[0]    #删除列表中的目录项，节约空间

path=r'C:\Program Files\internet explorer'
path=os.path.abspath(path)
showFiles(path,True)
