import psutil
def B2KMG(B):
    if B>=1024**3:
        return str(round(B/1024**3,1))+'GB'
    elif B>=1024**2:
        return str(round(B/1024**2,1))+'MB'
    elif B>=1024:
        return str(round(B/1024,1))+'KB'
    else:
        return str(B)+'B'

import psutil
print('进程号\t进程名\t\t状态\t\t用户\tCPU\t内存')
for p in psutil.process_iter():
    try:
        print(p.pid,
        p.name()[:14], #截断过长的名称
        p.status(),'',
        p.username().split('\\')[1], #只出现用户名，舍弃机器名
        p.cpu_percent(),
        B2KMG(p.memory_info().rss),
        sep='\t')
    except psutil.AccessDenied:
        pass
